<?php

session_start();
chdir("..");

include "./includes/variables.php";
include "./misc/database.php";
include "password_func.php";
include '/usr/local/php/beroConf.php';

$ba = new beroAri();
require_once("./includes/lang.php");

# pages to redirect
$redir_index	= "/app/berogui/index.php";
$redir_login	= "/app/berogui/includes/login.php";

# get redirection URL
if (isset($_GET['m'])) {
	$open_parm = 'm=' . $_GET['m'];
} elseif (isset($_GET['userapp'])) {
	$open_parm = 'userapp=' . $_GET['userapp'];
}

# check if user and password are set
if ((strlen(trim($HTTP_POST_VARS['user'])) == 0) || (strlen((trim($HTTP_POST_VARS['password']))) == 0)) {
	header('Location:' . $redir_login . '?reason=cred_empty' . ((!empty($open_parm)) ? '&' . $open_parm : ''));
	exit();
}

# extract username and password
$user		= htmlentities($HTTP_POST_VARS['user'], ENT_QUOTES);
$password	= $HTTP_POST_VARS['password'];

# check if user is in database
$result = $ba->select('SELECT * FROM users where user=\'' . $user . '\'');
if (!($row = $ba->fetch_array($result))) {
	header('Location:' . $redir_login . '?reason=cred_user' . ((!empty($open_parm)) ? '&' . $open_parm : ''));
	exit();
}

# check if password is valid
if(!tep_validate_password($password, $row['password'])) {
	header('Location:' . $redir_login . '?reason=cred_pass' . ((!empty($open_parm)) ? '&' . $open_parm : ''));
	exit();
}

# set session-parameters
$_SESSION['beroari_username']	= $row['user'];
$_SESSION['beroari_group']	= $row['group_'];
$_SESSION['beroari_time']	= time();

# check if group is 'users' (and open not existing module 'callsf'...)
if ($row['group_'] == 'users') {
	header("Location:" . $redir_index . "?m=callsf");
	exit();
}

# open root db, check if ari.db has to be created or if we can read from it
$bc		= new beroConf('root');
$result		= $ba->select("SELECT vnum FROM version");
$versionen	= file("/usr/local/www/berogui/includes/versionen.php");

# settings for both cases (table exists or not)
$sql		= '';
$version	= '';

if ($result != false) {						// Die Tabelle version exisitiert in der Datenbank.
	$row		= $ba->fetch_array($result);
	$show		= false;
}

foreach ($versionen as $zeile) {

	if ($result != false) {					// Die Tabelle version exisitiert in der Datenbank.
		// Wenn die Versionsnummer übereinstimmt mit der Versionsnummer der Datei, werden die SQL Statements ab dieser Zeile gespeichert
		if ($show && (strpos($zeile, "VERSION") === false)) {
			$sql		.= $zeile;
		}

		if (strpos($zeile, "VERSION") !== false) {
			$values		= split(' ',$zeile);
			$values[1]	= trim($values[1]);
			$version	= $values[1];

			if ($values[1] == $row['vnum']) {
				$show = true;
			}
		}
	} else {						// Die Tabelle version exisitiert nicht in der Datenbank.
		if (strpos($zeile, "VERSION") === false) {
			$sql		.= $zeile;
		} else {
			$values		= split(' ',$zeile);
			$values[1]	= trim($values[1]);
			$version	= $values[1];
		}

	}

	if ((($result != false) && ($show == true) || ($result == false)) && ($version == 13)){
		$query = $ba->select('SELECT * from dialplan ORDER BY id');

		while ($entry = $ba->fetch_array($query)) {

			if ($entry['isdnid']!="" && !in_array($entry['isdnid'],$misdnids)) {
				array_push($misdnids,$entry['isdnid']);
				$q = $ba->select("select fromId, dest, src, id, newDest, newSrc from dialplan " .
							"where isdnid='" . $entry['isdnid'] . "' and direction='isdn-sip'");
				$en = $ba->fetch_array($q);

				$q1 = $ba->select("select toId, dest, src, id, newDest, newSrc from dialplan " .
								"where isdnid='".$entry['isdnid']."' and direction='sip-isdn'");
				$en1 = $ba->fetch_array($q1);

				$ba->update("UPDATE dialplan set newDest='" . $entry['isdnid'] . $en1['newDest'] . "', newSrc='".$en1['newSrc'] .
								"' WHERE id='".$en['id']."'");

				$ba->update("UPDATE dialplan set newDest='\\\\1', newSrc='\\\\1' WHERE id ='". $en1['id']."'");
			}
		}
		$version = 14;
	}
}

# echo $sql
$sql = trim($sql);
if (strlen($sql) > 0) {
	$ba->exec_query($sql);
}
$ba->exec_query("UPDATE version SET vnum='" . $version . "'");


// Datenbank Überprüfung ob ISDN/Analog Daten gespeichert sind (wenn nicht, werden die Line Interfaces gelesen).
$query_isdn	= $ba->select("select lif, type from isdn group by lif");
$query_analog	= $ba->select("select lif, type from analog group by lif");
$query_gsm	= $ba->select("select lif, type from gsm group by lif");

if ((sqlite_num_rows($query_isdn) == 0) && (sqlite_num_rows($query_analog) == 0) && (sqlite_num_rows($query_gsm) == 0)) {

	$ba = new beroAri();

	$line_interfaces = array("li0", "li1");

	$li_mod_cfg["xhfc-4su"]["cnt"]		= 4;
	$li_mod_cfg["xhfc-4su"]["li0"]		= "INSERT INTO isdn (type, lif, master, config, port_type) VALUES('bf4S0','0','1','','BRI');";
	$li_mod_cfg["xhfc-4su"]["li1"]		= "INSERT INTO isdn (type, lif, master, config, port_type) VALUES('bf4S0','1','0','','BRI');";

	$li_mod_cfg["hfc-e1"]["cnt"]		= 1;
	$li_mod_cfg["hfc-e1"]["li0"]		= "INSERT INTO isdn (type, lif, master, config, port_type) VALUES('bf1E1','0','1','','PRI');";
	$li_mod_cfg["hfc-e1"]["li1"]		= "INSERT INTO isdn (type, lif, master, config, port_type) VALUES('bf1E1','1','0','','PRI');";

	$li_mod_cfg["hfc-2e1"]["cnt"]		= 2;
	$li_mod_cfg["hfc-2e1"]["li0"]		= "INSERT INTO isdn (type, lif, master, config, port_type) VALUES('bf2E1','0','1','','PRI');";
	$li_mod_cfg["hfc-2e1"]["li1"]		= "INSERT INTO isdn (type, lif, master, config, port_type) VALUES('bf2E1','1','0','','PRI');";

	$li_mod_cfg["telit-2GSM"]["cnt"]	= 2;
	$li_mod_cfg["telit-2GSM"]["li0"]	= "INSERT INTO gsm (type, lif, master, config, port_type) VALUES('bf2GSM','0','1','','GSM');";
	$li_mod_cfg["telit-2GSM"]["li1"]	= "INSERT INTO gsm (type, lif, master, config, port_type) VALUES('bf2GSM','1','1','','GSM');";

	$li_mod_cfg["si-4fxs"]["cnt"]		= 4;
	$li_mod_cfg["si-4fxs"]["li0"]		= "INSERT INTO analog (type, lif, master, config, port_type) VALUES('bf4FXS','0','1','','FXS');";
	$li_mod_cfg["si-4fxs"]["li1"]		= "INSERT INTO analog (type, lif, master, config, port_type) VALUES('bf4FXS','1','0','','FXS');";

	$li_mod_cfg["si-4fxo"]["cnt"]		= 4;
	$li_mod_cfg["si-4fxo"]["li0"]		= "INSERT INTO analog (type, lif, master, config, port_type) VALUES('bf4FXO','0','1','','FXO');";
	$li_mod_cfg["si-4fxo"]["li1"]		= "INSERT INTO analog (type, lif, master, config, port_type) VALUES('bf4FXO','1','0','','FXO');";

	$li_mod_cfg["xhfcSi-2s02fxs"]["cnt"]	= 2;
	$li_mod_cfg["xhfcSi-2s02fxs"]["li0"][0]	= "INSERT INTO isdn (type, lif, master, config, port_type) VALUES('bf2S02FXS','0','1','','BRI');";
	$li_mod_cfg["xhfcSi-2s02fxs"]["li0"][1]	= "INSERT INTO analog (type, lif, master, config, port_type) VALUES('bf2S02FXS','0','1','','FXS');";
	$li_mod_cfg["xhfcSi-2s02fxs"]["li1"][0]	= "INSERT INTO isdn (type, lif, master, config, port_type) VALUES('bf2S02FXS','1','0','','BRI');";
	$li_mod_cfg["xhfcSi-2s02fxs"]["li1"][1]	= "INSERT INTO analog (type, lif, master, config, port_type) VALUES('bf2S02FXS','1','0','','FXS');";

	foreach ($line_interfaces as $line_interface) {

		$res = file_get_contents("/proc/" . $line_interface);
		preg_match("/type: (?<" . $line_interface . ">.*)/", $res, $match);
		$li_type = $match[$line_interface];

		switch ($li_type) {
		case "xhfcSi-2s02fxs":								# special case ISDN & ANALOG
			for ($i = 0;$i < $li_mod_cfg[$li_type]["cnt"]; $i++) {
				 $ba->insert_($li_mod_cfg[$li_type][$line_interface][0]);
				 $ba->insert_($li_mod_cfg[$li_type][$line_interface][1]);
			}
			break;
		default:									# all other line interfaces
			for ($i = 0; $i < $li_mod_cfg[$li_type]["cnt"]; $i++) {
				$ba->insert_($li_mod_cfg[$li_type][$line_interface]);
			}
			break;
		}
	}

	$q = $ba->select("SELECT type, lif FROM isdn union SELECT type, lif FROM analog union SELECT type, lif FROM gsm order by lif");

	$i = 0;
	while ($ent=$ba->fetch_array($q)){
		$li[$i]		= $ent['lif'];
		$type[$i]	= $ent['type'];
		$i++;
	}

	$res=file_get_contents('/proc/cmdline');
	preg_match("/.*revision=(?<revision>.*)/",$res,$revision);
	$revision=$revision['revision'];

	if (($type[0]=="bf4S0" || $type[0]=="bf2S02FXS" || $type[0]=="bf4FXS" || $type[0]=="bf4FXO") && !isset($type[1]) &&
													$revision!="1.80" && $revision!="1.8") {

		$ba->select("select type, lif from isdn group by type,lif order by lif");
		$ba->select("INSERT into key_val VALUES('portswitch',1)");
	}

	if ($ba->is_error()){
		echo "<script>alert(".$ba->error().");</script>";
	}

	$query = $ba->select("select option from activate where id='activate'");
	while($entry = $ba->fetch_array($query)){
		if ($entry['option'] <= 3) {
			$query =  $ba->update("UPDATE activate SET option=3 where id='activate'");
		}
	}

}

# open berogui
header('Location:' . $redir_index . ((!empty($open_parm)) ? '?' . $open_parm : ''));
?>
